
new const PluginVersion[] = "1.0.0";

#include <amxmodx>
#include <hamsandwich>
#include <reapi>

const iImpulseCustomCode = 1000;

enum _: eWeapon_Struct {

	eWeapon_szMenu[32],
	eWeapon_iCost,
	eWeapon_iMinRound,

	eWeapon_szBase[32],
	Float: eWeapon_flDamage,
	eWeapon_szModelV[128],
	eWeapon_szModelP[128],
	eWeapon_szModelW[128]
};

new g_aWeaponData[][eWeapon_Struct] = {

	{
		"GIRL Deagle", // menu
		1000, // cost
		1, // min round

		"weapon_deagle", // base weapon
		1.6, // damage mod
		"models/uagungirl1/v_deagle.mdl",
		"models/uagungirl1/p_deagle.mdl",
		"models/uagungirl1/w_deagle.mdl"
	},
	{
		"GIRL M4A1-S", // menu
		3500, // cost
		2, // min round

		"weapon_m4a1", // base weapon
		1.3, // damage mod
		"models/uagungirl1/v_m4a1.mdl",
		"models/uagungirl1/p_m4a1.mdl",
		"models/uagungirl1/w_m4a1.mdl"
	},
	{
		"GIRL AK-47", // menu
		3000, // cost
		2, // min round

		"weapon_ak47", // base weapon
		1.3, // damage mod
		"models/uagungirl1/v_ak47.mdl",
		"models/uagungirl1/p_ak47.mdl",
		"models/uagungirl1/w_ak47.mdl"
	},
	{
		"GIRL AWP", // menu
		7000, // cost
		3, // min round

		"weapon_awp", // base weapon
		1.5, // damage mod
		"models/uagungirl1/v_awp.mdl",
		"models/uagungirl1/p_awp.mdl",
		"models/uagungirl1/w_awp.mdl"
	},
	{
		"GIRL M3", // menu
		2400, // cost
		2, // min round

		"weapon_m3", // base weapon
		1.5, // damage mod
		"models/uagunm3/v_m3.mdl",
		"models/uagunm3/p_m3.mdl",
		"models/uagunm3/w_m3.mdl"
	}	
};
new g_iSizeWeaponData = sizeof(g_aWeaponData);

public plugin_precache() {

	for(new a, iId, iBitRegister; a < g_iSizeWeaponData; a++)
	{
		precache_model(g_aWeaponData[a][eWeapon_szModelV]);
		precache_model(g_aWeaponData[a][eWeapon_szModelP]);
		precache_model(g_aWeaponData[a][eWeapon_szModelW]);

		iId = BIT(rg_get_weapon_info(g_aWeaponData[a][eWeapon_szBase], WI_ID));

		if(iBitRegister & iId)
		{
			continue;
		}

		iBitRegister |= iId;

		RegisterHam(Ham_Spawn, g_aWeaponData[a][eWeapon_szBase], "@CBasePlayerWeapon_Spawn_Post", .Post = true);
		RegisterHam(Ham_Item_Deploy, g_aWeaponData[a][eWeapon_szBase], "@CBasePlayerWeapon_Deploy_Post", .Post = true);
	}

	RegisterHookChain(RG_CWeaponBox_SetModel, "@CWeaponBox_SetModel_Pre", .post = false);
	RegisterHam(Ham_Touch, "weaponbox", "@CWeaponBox_Touch_Pre", .Post = false);
}

public plugin_init() {

	register_plugin("Girls Weapons", PluginVersion, "Ragamafona");

	//	register_clcmd("say /girls", "Show_MenuGirlsWeapon");

	register_menucmd(register_menuid("GirlsWeapon"), (1<<0|1<<1|1<<2|1<<3|1<<4|1<<9), "@Handle_GirlsWeapon");
}

public Show_MenuGirlsWeapon(const pPlayer) {

	if(rg_buytime_expired())
	{
		client_print(pPlayer, print_center, "Время закупки истекло!");
		return PLUGIN_HANDLED;
	}

	new szMenu[MAX_MENU_LENGTH];
	new iKeys = BIT(4)|BIT(9);
	new iMoney = get_member(pPlayer, m_iAccount);
	new iRound = get_member_game(m_iTotalRoundsPlayed) + 1;
	new a;

	formatex(szMenu, MAX_MENU_LENGTH - 1, "\rGIRL Оружейка^n^n");

	for(; a < g_iSizeWeaponData; a++)
	{
		if(iMoney < g_aWeaponData[a][eWeapon_iCost]
			|| iRound < g_aWeaponData[a][eWeapon_iMinRound])
		{
			strcat(szMenu, fmt("\d[%i] ^t%s \w[\r%i$\w]^n", 
				a + 1, g_aWeaponData[a][eWeapon_szMenu], g_aWeaponData[a][eWeapon_iCost]), MAX_MENU_LENGTH - 1);

			continue;
		}

		iKeys |= BIT(a);
		strcat(szMenu, fmt("\w[\r%i\w] ^t%s \w[\y%i$\w]^n",
			a + 1, g_aWeaponData[a][eWeapon_szMenu], g_aWeaponData[a][eWeapon_iCost]), MAX_MENU_LENGTH - 1);
	}

	iKeys |= BIT(a);
	strcat(szMenu, fmt("^n\w[\r%i\w] ^tНазад^n^n\w[\r0\w] ^tВыход", a + 1), MAX_MENU_LENGTH - 1);
	
	return show_menu(pPlayer, iKeys, szMenu, .title = "GirlsWeapon");
}

@Handle_GirlsWeapon(const pPlayer, const iKey) {

	if(iKey == 9 || !is_user_connected(pPlayer))
	{
		return PLUGIN_HANDLED;
	}

	if(iKey == g_iSizeWeaponData)
	{
		client_cmd(pPlayer, "vipmenu");
		return PLUGIN_HANDLED;
	}

	if(get_member(pPlayer, m_iAccount) < g_aWeaponData[iKey][eWeapon_iCost]
		|| get_member_game(m_iTotalRoundsPlayed) + 1 < g_aWeaponData[iKey][eWeapon_iMinRound])
	{
		return Show_MenuGirlsWeapon(pPlayer);
	}

	if(rg_buytime_expired())
	{
		client_print(pPlayer, print_center, "Время закупки истекло!");
		return PLUGIN_HANDLED;
	}

	new pWeapon = rg_give_custom_item(pPlayer, g_aWeaponData[iKey][eWeapon_szBase], GT_DROP_AND_REPLACE, iImpulseCustomCode + iKey);

	if(is_nullent(pWeapon))
	{
		return PLUGIN_HANDLED;
	}

	rg_add_account(pPlayer, -g_aWeaponData[iKey][eWeapon_iCost], AS_ADD);

	return PLUGIN_HANDLED;
}

@CBasePlayerWeapon_Spawn_Post(const pItem) {

	new iImpulse = get_entvar(pItem, var_impulse);

	if(!(iImpulseCustomCode <= iImpulse < (iImpulseCustomCode + g_iSizeWeaponData)))
	{
		return;
	}

	new iArrayPos = iImpulse - iImpulseCustomCode;

	set_member(pItem, m_Weapon_flBaseDamage, Float: get_member(pItem, m_Weapon_flBaseDamage) * g_aWeaponData[iArrayPos][eWeapon_flDamage]);

	set_entvar(pItem, var_noise1, g_aWeaponData[iArrayPos][eWeapon_szModelV]);
	set_entvar(pItem, var_noise2, g_aWeaponData[iArrayPos][eWeapon_szModelP]);
	set_entvar(pItem, var_noise3, g_aWeaponData[iArrayPos][eWeapon_szModelW]);

	set_member(pItem, m_Weapon_iClip, rg_get_iteminfo(pItem, ItemInfo_iMaxClip));
	set_member(pItem, m_Weapon_iDefaultAmmo, rg_get_iteminfo(pItem, ItemInfo_iMaxAmmo1));
}

@CBasePlayerWeapon_Deploy_Post(const pItem) {

	if(!(iImpulseCustomCode <= get_entvar(pItem, var_impulse) < (iImpulseCustomCode + g_iSizeWeaponData)))
	{
		return;
	}

	new pPlayer = get_member(pItem, m_pPlayer);
	new szModel[128];

	get_entvar(pItem, var_noise1, szModel, charsmax(szModel));
	set_entvar(pPlayer, var_viewmodel, szModel);

	get_entvar(pItem, var_noise2, szModel, charsmax(szModel));
	set_entvar(pPlayer, var_weaponmodel, szModel);
}

@CWeaponBox_SetModel_Pre(const pWeaponBox) {

	new pItem = UTIL_GetWeaponBoxItem(pWeaponBox);

	if(pItem == NULLENT)
	{
		return;
	}

	if(!(iImpulseCustomCode <= get_entvar(pItem, var_impulse) < (iImpulseCustomCode + g_iSizeWeaponData)))
	{
		return;
	}

	new szModel[128];

	get_entvar(pItem, var_noise3, szModel, charsmax(szModel));
	SetHookChainArg(2, ATYPE_STRING, szModel);
}

@CWeaponBox_Touch_Pre(const pWeaponBox, const pPlayer) {

	if(is_nullent(pWeaponBox) || !is_user_alive(pPlayer))
	{
		return HAM_IGNORED;
	}

	if(get_user_flags(pPlayer) & ADMIN_LEVEL_E)
	{
		return HAM_IGNORED;
	}

	new pItem = UTIL_GetWeaponBoxItem(pWeaponBox);

	if(!(iImpulseCustomCode <= get_entvar(pItem, var_impulse) < (iImpulseCustomCode + g_iSizeWeaponData)))
	{
		return HAM_IGNORED;
	}

	static Float: flLastMessage[MAX_PLAYERS + 1];
	static Float: flGameTime;

	flGameTime = get_gametime();

	if(flGameTime > flLastMessage[pPlayer])
	{
		flLastMessage[pPlayer] = flGameTime + 2.0;

		client_print(pPlayer, print_center, "Только для GIRL!");
	}

	return HAM_SUPERCEDE;
}

public plugin_natives() {

	register_native("force_open_girls_weapon", "@__force_open_girls_weapon", false);
}

@__force_open_girls_weapon() {

	Show_MenuGirlsWeapon(get_param(1));
}

stock UTIL_GetWeaponBoxItem(const pWeaponBox) {

	for(new iSlot, pItem; iSlot < MAX_ITEM_TYPES; iSlot++)
	{
		if(!is_nullent((pItem = get_member(pWeaponBox, m_WeaponBox_rgpPlayerItems, iSlot))))
		{
			return pItem;
		}
	}
	return NULLENT;
}

stock bool: rg_buytime_expired() {

	static mp_buytime;

	if(mp_buytime || (mp_buytime = get_cvar_pointer("mp_buytime")))
	{
		new Float: flBuyTime = get_pcvar_float(mp_buytime);

		if(flBuyTime == -1.0)  		// no limit
		{
			return false
		}

		if(flBuyTime == 0.0 || (get_gametime() - Float:get_member_game(m_fRoundStartTime) > (flBuyTime * 60)))
		{
			return true;
		}
	}

	return false;
}